import java.util.Random;

import commandcenter.CommandCenter;
import enumerate.Action;
import gameInterface.AIInterface;
import structs.CharacterData;
import structs.FrameData;
import structs.GameData;
import structs.Key;
import structs.MotionData;

/*
 * Developed by : Seonghun Yoon. Sejong University ( Korea )
 */
public class SniperInSejong implements AIInterface {

	public Key inputKey;
	public boolean playerNumber; 
	public FrameData frameData; 
	public CommandCenter cc;
	private GameData gd;
	
	private CharacterData characterdata;
	private CharacterData characterdata2;
	
	private int X = 0;
	
	//private State myMotionState;
	//private State EnermyMotionState;
	
	private String EnermyMotionName = "";
	private String MyMotionName = "";

	private long allFrame = 0;
	private long usingFrame = 0;
	private long changFrame = 0;
	
	private Random rand = new Random();
	
	int myEnergy = 0;
	int myHp = 0;
	
	boolean enermyDown = false;
	boolean enermyJangpung = false;
	boolean jangpungA = false;//IN AIR
	boolean jangpungG = false;//IN GROUND
	
	
	int myPx  = 0;
	int myPy  = 0;
	int hihgtFB = 50;
	int enPx  = 0;
	int preEnPx = 0;
	int EnemyL=0, EnemyR=0, EnemyT=0, MyL=0;
	
	
	boolean first = true;
	
	int backCnt = 0;
	
	int airType = 1;
	
	double hprate = 0;
	double preHprate = 0;
	
	boolean stopflag = true;
	int round = 0;
	
	int strategy = 1;
	int LowStrategy = 0;
	int NextRoundStrategy = 0;
	String command = "";
	
	boolean readyJump = false;
	
	int typeOfStrategy = 0;
	
	@Override
	public int initialize(GameData gameData, boolean playerNumber) { 
		gd = gameData;
		this.playerNumber = playerNumber;
		this.inputKey = new Key(); 
		cc = new CommandCenter();
		frameData = new FrameData(); return 0;
	}
	
	@Override
	public void getInformation(FrameData frameData) { 
		this.frameData = frameData; 
		cc.setFrameData(this.frameData, playerNumber);
	}
	
	public void firstStrategy(){
		if((frameData.getRemainingTime() < 30000) && (hprate > 3.0))
		{
			if (X >= 280 && myEnergy < 30)
			{
				command = "FOR_JUMP";
				if (MyMotionName.contains("AIR"))			inputKey.B = true;
			}else if ((X >= 280) && (myEnergy >= 30) && (X < 535))
			{
				if (EnermyMotionName.contains("AIR"))		cc.commandCall("STAND_D_DF_FB");
				else										cc.commandCall("STAND_D_DF_FA");
			}else
			{
				command = "CROUCH_B";
				if (cc.getMyCharacter().isFront() == true)	inputKey.R = true;
				else										inputKey.L = true;

				if (X >= 50 && X < 53)						cc.commandCall("CROUCH_FA");
				
				if (X >= 53 && X < 280)
				{
					command = "FOR_JUMP";
					inputKey.B = true;
				}
				if (myEnergy >= 300 && X < 535 && !EnermyMotionName.contains("AIR"))	command = "STAND_D_DF_FC";
			}
			cc.commandCall(command);
		}else
		{
			if(stopflag || round != frameData.getRound())
			{
				if(round != frameData.getRound())
				{
					cc.commandCall("STAND_D_DF_FA");
					stopflag = true;
					round++;
				}
				else if(X==535)		cc.commandCall("FOR_JUMP");
				else				stopflag = false;
			}else
			{
				if( EnermyMotionName.equals("STAND_D_DF_FC") || EnermyMotionName.equals("STAND_D_DF_FA")
						|| EnermyMotionName.equals("STAND_D_DF_FB") && X < 540){
					if(MyL > EnemyL && EnemyL > 300)			cc.commandCall("9");
					else if(MyL < EnemyL && EnemyL < 600)		cc.commandCall("9");
					else if( X <= 357)							cc.commandCall("9");
					else if( X > 357 && X <= 540)				cc.commandCall("7");
				}
				if(X >=150 && X < 535 && myEnergy>=300)			cc.commandCall("STAND_D_DF_FC");
				
				if(X >=150 && X < 535 && myEnergy>=30 && !MyMotionName.contains("AIR"))	cc.commandCall("STAND_D_DF_FB");
				if(X >=300 && !EnermyMotionName.contains("AIR"))						cc.commandCall("STAND_D_DF_FA");
				
				if(X <300)
				{	
					if(myEnergy >=30 && myPx<680 && myPx>-91 && (rand.nextInt()%4 != 0))cc.commandCall("7");
					
					if(!MyMotionName.contains("AIR"))									cc.commandCall("9");
					else																cc.commandCall("B");
				}
			}
		}
	}

	public void shortDistance(){
		///////////////////////////////Basic Strategy
		if( myEnergy > 300 && !EnermyMotionName.contains("AIR") && X > 175 ){//300!!
			cc.commandCall("STAND_D_DF_FC");
			return;
		}
		if ( EnermyMotionName.equals("STAND_D_DF_FC") ){//300!!
			cc.commandCall("FOR_JUMP");
			return;
		}
//		if( (myPx <= -110 && enPx > myPx) ||
//				(myPx >= 670 && enPx < myPx )){
//			cc.commandCall("BACK_JUMP");//벽 등진거
//		}
		///////////////////////////////
		if (cc.getDistanceX() >= 280) {
			cc.commandCall("FOR_JUMP");
			if (cc.getMyCharacter().getState().name().equals("AIR"))		inputKey.B = true;
		}else if (cc.getDistanceX() >= 280 && cc.getMyEnergy() >= 60) {
			if (cc.getEnemyCharacter().getState().name().equals("AIR"))		cc.commandCall("STAND_D_DF_FB");
			if(!cc.getEnemyCharacter().getState().name().equals("AIR")){
				cc.commandCall("STAND_D_DF_FA");
				if(cc.getMyEnergy()>=400)									cc.commandCall("STAND_D_DF_FC");
			}
			else															cc.commandCall("STAND_D_DF_FC");
		}else if(cc.getDistanceX() >= 207 && cc.getDistanceX()<=244)		cc.commandCall("THROW_B");
		else if(cc.getDistanceX() >= 70 && cc.getDistanceX() <=77 )			cc.commandCall("THROW_B");
		else if (cc.getDistanceX() >= 53 && cc.getDistanceX() < 280)
		{
			cc.commandCall("FOR_JUMP");
			if (cc.getMyCharacter().getState().name().equals("AIR"))	inputKey.B = true;
		}else {
			if( EnermyMotionName.equals("CROUCH_B") && !MyMotionName.contains("AIR") ){
				cc.commandCall("STAND_A");
			}else{
				cc.commandCall("CROUCH_B");
				if (cc.getMyCharacter().isFront() == true)		inputKey.R = true;
				else											inputKey.L = true;

				if (cc.getDistanceX() >= 50 && cc.getDistanceX() < 53)		cc.commandCall("CROUCH_FA");
				if (cc.getDistanceX() >= 53 && cc.getDistanceX() < 280) {
					cc.commandCall("FOR_JUMP");
					if (cc.getMyCharacter().getState().name().equals("AIR"))	inputKey.B = true;
				}
			}
		}
	}

	public void airStrategy1(){			//air Strategy1 ���� ������
		if( myEnergy >= 300 &&  !EnermyMotionName.contains("AIR") )				cc.commandCall("STAND_D_DF_FC");
		
		if( (EnermyMotionName.equals("STAND_D_DF_FA") || EnermyMotionName.equals("STAND_D_DF_FB")) ||  EnermyMotionName.equals("STAND_D_DF_FC") ){
			if( MyMotionName.equals("AIR") )									inputKey.B = true;
			else{
				if(MyL > EnemyL && EnemyL > 300)
				{
					inputKey.A = false;
					inputKey.B = false;
					cc.commandCall("FOR_JUMP");
					inputKey.B = true;
				}
				else if(MyL < EnemyL && EnemyL < 600)
				{
					inputKey.A = false;
					inputKey.B = false;
					cc.commandCall("FOR_JUMP");
					inputKey.B = true;
				}
				else if(X <= 535)
				{
					inputKey.A = false;
					inputKey.B = false;
					cc.commandCall("FOR_JUMP");
					inputKey.B = true;
				}else{
					inputKey.A = false;
					inputKey.B = false;
					cc.commandCall("DASH");
				}
			}
		}
		
		if( X < 150 ) {
			
			if( myPx <= -110 || myPx >= 670 ){
				//System.out.println("ESCAPE!!!!!!!!");
				inputKey.B = false;
				inputKey.A = false;
				cc.commandCall("FOR_JUMP");
				inputKey.B = true;
			}else if( X == 0 ){		
				cc.commandCall("THROW_A");
			}else if(!MyMotionName.contains("AIR")){
				inputKey.B = false;
				cc.commandCall("FOR_JUMP");
				inputKey.B = true;
			}else if(!MyMotionName.contains("AIR") && EnermyMotionName.contains("AIR")){
				inputKey.B = false;
				cc.commandCall("BACK_JUMP");
				inputKey.B = true;
			}else{
				if( !EnermyMotionName.contains("AIR") ){
					inputKey.A = false;
					if( !EnermyMotionName.contains("CROUCH") )	inputKey.D = true;
					inputKey.B = true;
				}else{
					inputKey.B = false;
					inputKey.A = true;
				}
			}
		}else{
			if(!MyMotionName.contains("AIR")){
				inputKey.A = false;
				inputKey.B = false;
				if( X >= 535)	cc.commandCall("DASH");
				else 			cc.commandCall("FOR_JUMP");
			}else{
				inputKey.A = false;
				if( myEnergy >=50 && X <= 550 && X >= 170 && rand.nextDouble() <= 0.3 ) 	cc.commandCall("AIR_D_DF_FB");
				else if( myEnergy >=30 && X <= 550 && X >= 170 && rand.nextDouble() <= 0.7 ) 	cc.commandCall("STAND_D_DF_FB"); 
				else					inputKey.B = true;
				//inputKey.B = true;
			}
		}
		
	}

	public void airStrategy2(){
		///////////////////////////////Basic Strategy
		if( myEnergy > 300 && !EnermyMotionName.contains("AIR") && X > 175 ){//300!!
			cc.commandCall("STAND_D_DF_FC");
			return;
		}
		if ( EnermyMotionName.equals("STAND_D_DF_FC") ){//300!!
			cc.commandCall("FOR_JUMP");
			return;
		}
		///////////////////////////////
		if (X < 40) {
			if( myPx <= -110 || myPx >= 670 ){
				//System.out.println("ESCAPE!!!!!!!!");
				inputKey.B = false;
				inputKey.A = false;
				cc.commandCall("FOR_JUMP");
				inputKey.B = true;
			}else if( X == 0 ){		
				cc.commandCall("THROW_A");
			}else if(!MyMotionName.contains("AIR")){
				cc.commandCall("FOR_JUMP");
				inputKey.B = true;
			}else if(!MyMotionName.contains("AIR") && EnermyMotionName.contains("AIR")){
				cc.commandCall("BACK_JUMP");
				inputKey.B = true;
			}else{
				if( !EnermyMotionName.contains("AIR") ){
					inputKey.A = false;
					if( !EnermyMotionName.contains("CROUCH") )	inputKey.D = true;
					inputKey.B = true;
				}else{
					inputKey.B = false;
					inputKey.A = true;
				}
			}
		}else if(X < 220){
			inputKey.B = false;
			inputKey.A = false;
			cc.commandCall("FOR_JUMP");
			inputKey.B = true;
		}else if (X >= 220 ) {
			inputKey.B = false;
			inputKey.A = false;
			
			if( 	 myEnergy >=50 && X <= 550 && X >= 170 && !jangpungA && rand.nextDouble() <= 0.4 && (characterdata.getSpeedX() >= 0 ^ characterdata.isFront() )){
				cc.commandCall("AIR_D_DF_FB");	
				jangpungA = true;
			}
			else if( myEnergy >=30 && X <= 550 && X >= 170 && !jangpungG ){
				cc.commandCall("STAND_D_DF_FB");
				jangpungG = true;
			}
			else if( 				  X <= 550 && X >= 170 && rand.nextDouble() <= 0.7 ){
				cc.commandCall("STAND_D_DF_FA");
				jangpungA = false;				
			}
			else if( myEnergy >=30 && X <= 300 && X >= 170 && rand.nextDouble() <= 0.7 ) 	cc.commandCall("STAND_F_D_DFB");//�ϴ� ���� ���� ����
			else if( !jangpungA && EnermyMotionName.contains("AIR") && rand.nextDouble() <= 0.1 && (characterdata.getSpeedX() >= 0 ^ characterdata.isFront() )){
				cc.commandCall("AIR_D_DF_FA");
				jangpungG = false;
			}else{
				if( rand.nextDouble() <= 7.0 ){
					jangpungG = false;
					cc.commandCall("FOR_JUMP");
				}else if( rand.nextDouble() <= 7.0 )
					jangpungG = false;
					cc.commandCall("BACK_JUMP");
			}
		}
	}
	
	@Override
	public void processing() {
		
		
		if (!frameData.getEmptyFlag() && frameData.getRemainingTime() > 0) {
			allFrame = frameData.getRemainingTime();
			usingFrame = 60000 - allFrame;
			
			characterdata  = cc.getMyCharacter();
			characterdata2 = cc.getEnemyCharacter();

			//�� ������
			myEnergy = characterdata.getEnergy();
			
			//���� ��ǥ, ���� ��ǥ
			myPx  = characterdata.getX();
			
			myPy = characterdata.getY();
			enPx = characterdata2.getX();
			
			//System.out.println("Y : "+myPy);
			
			X = cc.getDistanceX();

			EnemyL = characterdata2.getLeft();	//���� ��Ʈ �ڽ� ���� ���� ��ġ X�� ����
			EnemyR = characterdata2.getRight();	//���� ��Ʈ �ڽ� ���� ������ ��ġ X�� ����
			EnemyT = characterdata2.getTop();
			
			MyL = characterdata.getLeft();
			
			
			myHp = cc.getMyHP();
			hprate = (myHp-1.0) / (cc.getEnemyHP()-1.0);
			//System.out.println("characterdata.getSpeedX() : "+characterdata.getSpeedX());

			//���� ��� ��� �˾Ƴ���
			Action oppAct = characterdata2.getAction();
			Action myAct = characterdata.getAction();
			
			MotionData oppMotion = new MotionData();
			MotionData myMotion = new MotionData();	//��� ���� ��ü ����
			
			
			if (playerNumber){
				oppMotion = gd.getPlayerTwoMotion().elementAt(oppAct.ordinal());
				myMotion = gd.getPlayerOneMotion().elementAt(myAct.ordinal());	//p2�� ��� �����͸� ��´�
			}
			else{
				oppMotion = gd.getPlayerOneMotion().elementAt(oppAct.ordinal());
				myMotion = gd.getPlayerOneMotion().elementAt(myAct.ordinal());
			}
				
			EnermyMotionName = oppMotion.getMotionName();
			MyMotionName = myMotion.getMotionName();

			//System.out.println("myPx : "+myPx+" hprate : "+hprate+" MyHP : "+cc.getMyHP());
			
			if (cc.getskillFlag()) {
				inputKey = cc.getSkillKey();
			} else {
				inputKey.empty();
				cc.skillCancel();
				
				
				if( myHp == 0 && characterdata2.getHp() == 0 && usingFrame >= 25000  ){
					if( X < 200 ){
						//System.out.println("shortDistance()");
						shortDistance();
					}else{
						//System.out.println("firstStrategy()");
						firstStrategy();
					}
				}else if( ( myHp == 0 && characterdata2.getHp() != 0 ) || hprate < 0.63 ){//내 체력 비율이 높을 경우

					//System.out.println("Avoid!!!!!!!!!!!!!");
					
					if( myEnergy > 300 && !EnermyMotionName.contains("AIR") && X > 175 )//300!!
						cc.commandCall("STAND_D_DF_FC");
					if ( EnermyMotionName.equals("STAND_D_DF_FC") )//300!!
						cc.commandCall("FOR_JUMP");
					
					//Avoid!!!!!!!!!!!!!
					if( myPx == -120 || myPx == 680 ){
						if( X > 560 ){
							if( (myPx == -120 || myPx == 680) && myEnergy >= 30 && !MyMotionName.contains("AIR") )  cc.commandCall("STAND_D_DF_FB");
							else if( (myPx == -120 || myPx == 680) && !MyMotionName.contains("AIR") && rand.nextDouble() <= 0.5 )  cc.commandCall("STAND_D_DF_FA");
							//else																					cc.commandCall("BACK_JUMP");													
						}else if( X < 100 ){
							cc.commandCall("FOR_JUMP");
						}
					}
					
					//장풍이 날라올 경우
					if(EnermyMotionName.equals("STAND_D_DF_FA")
							|| EnermyMotionName.equals("STAND_D_DF_FB") && X < 540){
						if(MyL > EnemyL && EnemyL > 300)
						{
							cc.commandCall("9");
						}
						else if(MyL < EnemyL && EnemyL < 600)
						{
							cc.commandCall("9");
						}
						else if( X <= 357)
						{
							cc.commandCall("9");
						}
						else if( X > 357 && X <= 540)
						{	
							cc.commandCall("7");
						}
						if (cc.getMyCharacter().getState().name().equals("AIR"))	cc.commandCall("AIR_D_DF_FA");
					}
					
					if( myPx <= enPx && enPx > 540 ){
						//I am left.
						//center is 380
						//jangpung is 560
						//| o   ...  o x |
						inputKey.B = false;
						cc.commandCall("BACK_JUMP");
						if (cc.getMyCharacter().getState().name().equals("AIR"))	cc.commandCall("AIR_D_DF_FA");
						else if( myEnergy >= 30)									cc.commandCall("STAND_D_DF_FB");
						else														cc.commandCall("STAND_D_DF_FA");
						inputKey.B = true;
					}else if( myPx <= enPx && myPx < 220 ){
						//| o..o x       |							
						//I can be damaged jangpung. 
						airStrategy2();
					}else if( myPx > enPx && enPx < 220 ){
						//| x o  ... o  |
						cc.commandCall("BACK_JUMP");
						if (cc.getMyCharacter().getState().name().equals("AIR"))	cc.commandCall("AIR_D_DF_FA");
					}else if( myPx > enPx && myPx > 540 ){
						//|      x o..o |
						airStrategy2();
					}else{
						firstStrategy();
					}
				}else if( hprate >= 1.2){//접근전
					if( enPx == preEnPx ) {
						airStrategy1();
					}else{
						shortDistance();
					}
				}else{
					shortDistance();
				}	
				
				if( usingFrame%10000 == 0 ){
					preEnPx = enPx;
				}
			}
		}
	}
	
	@Override
	public Key input() { 
		return inputKey;
	}
	
	@Override
	public void close(){
		
	}
	
	@Override
	public String getCharacter(){
		return CHARACTER_ZEN;
	}
}
